﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CricketScorebook.Model
{
    abstract class Dismissal : DeliveryOutcome
    {
        public abstract DismissalType getDismissalType();
    }

    class FielderDismissal : Dismissal
    {
        protected FielderDismissalType dismissalType;
        protected Player fielder;

        public FielderDismissal(FielderDismissalType dismissalType, Player fielder)
        {
            this.dismissalType = dismissalType;
            this.fielder = fielder;
            fielder.addDismissal(this);
        }
        
        public override DismissalType getDismissalType()
        {
            return dismissalType;
        }

        public Player getFielder()
        {
            return fielder;
        }
    }

    class NonFielderDismissal : Dismissal
    {
        protected NonFielderDismissalType dismissalType;

        public NonFielderDismissal(NonFielderDismissalType dismissalType)
        {
            this.dismissalType = dismissalType;
        }

        public override DismissalType getDismissalType()
        {
            return dismissalType;
        }
    }
}
