﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CricketScorebook.Model
{
    class Player
    {
        protected Name name;
        protected Batting batting;
        protected Bowling bowling;
        protected Fielding fielding;
        
        public Player(Name name)
        {
            this.name = name;
            batting = new Batting();
            bowling = new Bowling();
            fielding = new Fielding();
        }

        public Name getName()
        {
            return name;
        }

        // BATTING
        protected Batting getBatting()
        {
            return batting;
        }

        public void addDelivery(Delivery delivery)
        {
            batting.addDelivery(delivery);
        }

        public int getRunsScored()
        {
            return batting.getRuns();
        }

        public int getBallsFaced()
        {
            return batting.getBallsFaced();
        }

        public int getFours()
        {
            return batting.getFours();
        }

        public int getSixes()
        {
            return batting.getSixes();
        }

        public Dismissal getDismissal()
        {
            return batting.getDismissal();
        }

        // BOWLING
        protected Bowling getBowling()
        {
            return bowling;
        }

        public void addOver(Over over)
        {
            bowling.addOver(over);
        }

        public int getNumOvers()
        {
            return bowling.getNumOvers();
        }

        public int getMaidens()
        {
            return bowling.getMaidens();
        }

        public int getWickets()
        {
            return bowling.getWickets();
        }

        public int getRunsCohceded()
        {
            return bowling.getRuns();
        }

        public int getWides()
        {
            return bowling.getWides();
        }

        public int getNoBalls()
        {
            return bowling.getNoBalls();
        }

        // FIELDING
        protected Fielding getFielding()
        {
            return fielding;
        }

        public void addDismissal(FielderDismissal dismissal)
        {
            fielding.addDismissal(dismissal);
        }

        public int getCatches()
        {
            return fielding.getCatches();
        }

        public int getRunOuts()
        {
            return fielding.getRunOuts();
        }

        public int getStumping()
        {
            return fielding.getStumpings();
        }
    }
}
